<?php
class fb_login_wid extends WP_Widget {
	private $appId,$appSecret;
	public function __construct() {
		$this->appId = get_option('afo_fb_app_id');
		add_action( 'wp_enqueue_scripts', array( $this, 'register_plugin_styles' ) );
		parent::__construct(
	 		'fb_login_wid',
			'FB Login Widget AFO',
			array( 'description' => __( 'This is a facebook social login form in the widget.', 'facebook-login-afo' ), )
		);
	 }

	public function widget( $args, $instance ) {
		extract( $args );
		
		$wid_title = apply_filters( 'widget_title', $instance['wid_title'] );
		
		echo $args['before_widget'];
		if ( ! empty( $wid_title ) )
			echo $args['before_title'] . $wid_title . $args['after_title'];
			$this->loginForm( $args['widget_id'] );
		echo $args['after_widget'];
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['wid_title'] = strip_tags( $new_instance['wid_title'] );
		return $instance;
	}


	public function form( $instance ) {
		$wid_title = @$instance[ 'wid_title' ];
		?>
		<p><label for="<?php echo $this->get_field_id('wid_title'); ?>"><?php _e('Title','facebook-login-afo'); ?> </label>
		<input class="widefat" id="<?php echo $this->get_field_id('wid_title'); ?>" name="<?php echo $this->get_field_name('wid_title'); ?>" type="text" value="<?php echo $wid_title; ?>" />
		</p>
		<?php 
	}
	
	public function social_logins(){ 
	?>
    <div class="social-login-text"><?php _e('Login with','facebook-login-afo');?> </div> <a href="javascript:void(0);" onClick="FBLogin();"><img src="<?php echo plugins_url( 'images/facebook.png' , __FILE__ );?>" alt="<?php _e('Fb Connect','facebook-login-afo');?>" title="<?php _e('Login with facebook','facebook-login-afo');?>" /></a>
    <?php do_action( 'additional_logins_afo' ); ?>
	<?php
	}
	
	public static function curPageURL() {
		$pageURL = 'http';
		if (isset($_SERVER["HTTPS"]) and $_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
		$pageURL .= "://";
		if (isset($_SERVER["SERVER_PORT"]) and $_SERVER["SERVER_PORT"] != "80") {
			$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
		} else {
			$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		}
		return $pageURL;
	}
	
	public function loginForm( $wid_id = '' ){
		global $post;
		$this->LoadScript();
		$redirect = $this->curPageURL();
		if(!is_user_logged_in()){
		?>
		<div id="log_forms" class="log_forms <?php echo $wid_id;?>">
        <?php $this->error_message();?>
		<form name="login" id="login" method="post" action="">
		<input type="hidden" name="option" value="afo_user_login" />
		<input type="hidden" name="redirect" value="<?php echo esc_url( $redirect ); ?>" />
		<div class="log-form-group">
			<label for="username"><?php _e('Username','facebook-login-afo');?> </label>
			<input type="text" name="user_username" required="required"/>
		</div>
		<div class="log-form-group">
			<label for="password"><?php _e('Password','facebook-login-afo');?> </label>
			<input type="password" name="user_password" required="required"/>
		</div>
        
        <?php do_action('login_afo_form');?>
        
        <?php do_action('login_form');?>
		
        <div class="log-form-group"><input name="login" type="submit" value="<?php _e('Login','facebook-login-afo');?>" /></div>
        
        <div class="locial-logins"><?php $this->social_logins();?></div>
		</form>
		</div>
		<?php 
		} else {
		$current_user = wp_get_current_user();
     	
		$link_with_username = __('Howdy, ','facebook-login-afo') . $current_user->display_name;
		?>
		<div class="logged-in"><?php echo $link_with_username;?> | <a href="<?php echo wp_logout_url($redirect); ?>" title="<?php _e('Logout','facebook-login-afo');?>"><?php _e('Logout','facebook-login-afo');?></a></div>
		<?php 
		}
	}
	
	private function LoadScript(){
	?>
	<script type="text/javascript">
    window.fbAsyncInit = function() {
    FB.init({
      appId      : '<?php echo $this->appId?>',
      cookie     : true,  
      xfbml      : true,  
      version    : 'v2.8'
    });
    };
    (function(d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s); js.id = id;
    js.src = "//connect.facebook.net/en_US/sdk.js";
    fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));
    function FBLogin() {
    FB.login(function (response) {
        if (response.authResponse) {
            processFbUserData();
        } else {
            alert('User cancelled login or did not fully authorize.');
        }
    }, {scope: 'email'});
    }
    function processFbUserData(){
    FB.api('/me', {locale: 'en_US', fields: 'id,first_name,last_name,email'},
    function (response) {	
        jQuery.ajax({
        method: "POST",
        dataType: "json",
        data: { "option": "fblogin", "id":response.id, "first_name":response.first_name, "last_name":response.last_name, "email":response.email }
        })
        .done(function( data ) {
            if(data.status == 'success'){
                // reload this page 
                location.reload();
            } else {
                alert(data.msg);
            }
        });
    });
    }
    </script>
	<?php
	}
	
	public function error_message(){
		if(isset($_SESSION['msg']) and $_SESSION['msg']){
			echo '<div class="'.$_SESSION['msg_class'].'">'.$_SESSION['msg'].'</div>';
			unset($_SESSION['msg']);
			unset($_SESSION['msg_class']);
		}
	}
	
	public function register_plugin_styles() {
		wp_enqueue_style( 'style_login_widget', plugins_url( 'facebook-login-afo/style_login_widget.css' ) );
	}
	
} 

add_action( 'widgets_init', create_function( '', 'register_widget( "fb_login_wid" );' ) );
